Subject: On modified lines containing 🌐︎ and Unicode VS15 in text mode emacs does not show the real content of the lines

From: Дилян Палаузов<[email-masked]>
Date: Sat, 21 Oct 2023 14:07:52 +0200

Hello,

I have a text unix file u.txt where I insert this line:

t.add('🌐︎ ' + 'abcd')

That is a globe U+1F310 followed by Unicode Variation Selector 15 to remove the colour of the globe.

$ hexdump -C  u.txt
00000000  74 2e 61 64 64 28 27 f0  9f 8c 90 ef b8 8e 20 27  |t.add('....... '|
00000010  20 2b 20 27 61 62 63 64  27 29 0a                 | + 'abcd').|
0000001b

I open the file in text mode, emacs-fedora-28.3 -nw, and press the right arrow repeatedly to go over c.  Then I press x.  emacs shows that c is deleted and on its place appears x. I press Ctrl+L to refresh.  Now c appears before x.

I close emacs, repeat the above steps and get consistent results.  I try this on a different system with self-compiled emacs 29.1, same results.

The problem report is that when that character sequence is contained in a text file, modifying more complex lines gets practically impossible with emacs, as the latter stops showing the actual text.  I have to refresh, close, open emacs several times in order to get modifications correctly on the lines, containing the above sequence.  I literally  cannot see what I am changing on such lines, as what is displayed is different to what is actually modified.

Kind regards
  Dilyan